# BLUPF90 guided study

# LAB 1 - University of Florida, 2022 

#@dodo128
cd /home/natalia/blupf90-uf/lab1


#=========================================================================================================
# Ex 01

#Read the Documentation for BLUPF90 program in the wiki: 
http://nce.ads.uga.edu/wiki/doku.php?id=documentation#tutorial



#=========================================================================================================
# Ex 02

#Browse through FAQ for blupf90 programs 
http://nce.ads.uga.edu/wiki/doku.php?id=faq


***** TIP *********
#read the manual and tutorial material for different models and situations 
http://nce.ads.uga.edu/wiki/lib/exe/fetch.php?media=blupf90_all2.pdf
http://nce.ads.uga.edu/wiki/lib/exe/fetch.php?media=tutorial_blupf90.pdf
*******************



#=========================================================================================================
# Ex 03
 
#Run 'renumf90' then 'blupf90' and obtain reliability

# Required files: data file, pedigree file, parameter file (specific to RENUMF90)
# datafile:

#Options needed for blupf90:
OPTION sol se     # Use YAMS to solve M

# Running renumf90 and saving the log file
renumf90 renum.par_ex3 | tee renum.log


***** TIP *********
# always save the log when you run the softawe - that is not saved by default 
"-" can be used. In this way the output of the software will not be printed on the screen
renumf90 renum.par_ex3 | tee > renum.log
*******************


#RENUMF90 will generate a file: renf90.par - this is the parameter file for the other programs in the BLUPF90 suit 

#Check renf90.par

#Running blupf90 and saving the log file
blupf90 renf90.par | tee blup.log


# Now we need original IDs of the animals to compare with the book's results

# Remember, renadxx.ped file has both renumbered (column 1) and original IDs (column 10) 
# that allow us to cross reference with solutions
# '+' means skips colums (+0= skip 0 columns) ; '-' means sort by column (-1= sort by column 1)
awk '{print $1, $10}' renadd02.ped | sort +0 -1 > ids.temp  #renumbered id, original id

#getting the EBV and SE for animals - with the renumbered id
awk '{if ($2==2) print $3,$4,$5}' solutions | sort +0 -1 > ebv.temp 

# With files sorted, let's use join 
join -1 1 -2 1 ids.temp ebv.temp | awk ' {print $2, $3, $4}' | sort +0 -1 > ebv_se #this file contains original id, ebv, se

#Now we need to obtain reliability

# REL= 1- PEV/var.a
# PEV= SE*SE 
# ACC= sqrt(REL)
 
awk '{print $1, $2, 1-$3*$3/20, (1-$3*$3/20)**0.5, $3}' ebv_se > rel_acc #original_id, ebv, rel, acc, se 

rm *.temp  #removing temporary files 


#=========================================================================================================
# Ex 04 and 05

# Read the documentation for 'remlf90' and 'airemlf90'
http://nce.ads.uga.edu/wiki/doku.php

http://nce.ads.uga.edu/wiki/doku.php?id=readme.reml
http://nce.ads.uga.edu/wiki/doku.php?id=readme.aireml


#=========================================================================================================
# Ex 06

cd /home/natalia/blupf90-uf/lab1/ex6
cp ../exmr99s1 .  #parameter file for single trait model 
cp ../exmr99s2 .  #parameter file for two trait model 
cp ../exmr99ss .  #parameter file for three trait model 
cp ../renpe99s .  #pedigree file 
cp ../renco99s .  #data file 


#Check the the three parameter files


#SINGLE TRAIT MODEL:

#Running REMLF90 for the single trait model:
#calculating the time:
time echo exmr99s1 | remlf90 | tee reml_1.log

real    0m2.435s
user    0m16.663s
sys     0m0.799s

Final Estimates
 Genetic variance(s) for effect  2
   1091.
 Genetic variance(s) for effect  3
   2304.
 Residual variance(s)
   1806.
 solutions stored in file: "solutions" 
 
 
 ***** TIP *********
#After running REMLF90 or AIREML the EBV will be automatically available in the file 'solutions'
#Those EBV are calculated with the updated variance components (the ones you estimated)
*******************


#Running AIREMLF90 for the single trait model:
#calculating the time:
time airemlf90 exmr99s1 | tee aireml_1.log

real    0m0.697s
user    0m10.014s
sys     0m0.517s


Final Estimates
 Genetic variance(s) for effect  2
   1091.6
 Genetic variance(s) for effect  3
   2303.7
 Residual variance(s)
   1806.4

! airemlf90 is much faster, converging in 6 rounds vs 70 rounds for remlf90
! Also note that 'airemlf90' provides SE for parameters, which are not available from 'remlf90'
! See notes for more details


 ***** TIP *********
# 'Solutions' file is rewritten when a software is rerun inside the folder 
# be careful to rename the solutions file after each software you run 
*******************


#TWO TRAIT MODEL:

#Running REMLF90 for the single trait model:
#calculating the time:
time echo exmr99s2 | remlf90 | tee reml_2.log

#Running AIREMLF90 for the single trait model:
#calculating the time:
time airemlf90 exmr99s2 | tee aireml_2.log


#Now let`s add the options to calculate the heritabilities and genetic correlations with AIREML - two trait model 
#see AIREMLF90 documentation for more details 

OPTION se_covar_function p.var_t1 G_2_2_1_1+G_3_3_1_1+R_1_1          # Phenotypic variance for trait 1
OPTION se_covar_function p.var_t2 G_2_2_2_2+G_3_3_2_2+R_2_2          # Phenotypic variance for trait 2

OPTION se_covar_function h2_t1 G_3_3_1_1/(G_2_2_1_1+G_3_3_1_1+R_1_1) # Heritability for trait 1
OPTION se_covar_function h2_t2 G_3_3_2_2/(G_2_2_2_2+G_3_3_2_2+R_2_2) # Heritability for trait 2

#Formula for genetic correlation: cov_a_t1_t2/sqrt(var_a_t1 * var_a_t2)
OPTION se_covar_function rg12 G_3_3_1_2/(G_3_3_1_1*G_3_3_2_2)**0.5   # Genetic correlation between traits 1 and 2


 ***** TIP *********
# OPTIONS can be added directly to renf90.par (but you can also include options in renum.par --> those will be transferred to renf90.par)
*******************


Sampling variances of covariances function of random effects (n=10000)
p.var_t1  - Function: g_2_2_1_1+g_3_3_1_1+r_1_1
  Mean:    5204.5
  Sample Mean:    5203.5
  Sample SD:    160.41

p.var_t2  - Function: g_2_2_2_2+g_3_3_2_2+r_2_2
  Mean:    4453.5
  Sample Mean:    4452.4
  Sample SD:    125.16

h2_t1  - Function: g_3_3_1_1/(g_2_2_1_1+g_3_3_1_1+r_1_1)
  Mean:   0.44174
  Sample Mean:   0.44060
  Sample SD:   0.44415E-01

h2_t2  - Function: g_3_3_2_2/(g_2_2_2_2+g_3_3_2_2+r_2_2)
  Mean:   0.33345
  Sample Mean:   0.33305
  Sample SD:   0.40209E-01

rg12  - Function: g_3_3_1_2/(g_3_3_1_1*g_3_3_2_2)^0.5
  Mean:   0.76343
  Sample Mean:   0.76278
  Sample SD:   0.43957E-01
 elapsed time  4.7731400E-02
 

#=========================================================================================================
# Ex 07

cd /home/natalia/blupf90-uf/lab1/ex7
cp ../exmr99s1 .  #parameter file for single trait model 
cp ../renco99s .  #data file 
cp ../renpe99s .  #pedigree file 

# How to run 'gibbsf90' programs?
. name of parameter file
. number of samples
. burn-in
. sampling interval

Methods to run:
1- 'gibbs2f90'       # type inputs as the program ask
2- echo -e "exmr99s1 \n 100 0 \n 1" | gibbs2f90 | tee gibbs.log
3- script:
			gibbs2f90 < <AA > gibbs.log
			exmr99s1
			1000 0
			1
			AA   

echo -e "exmr99s1 \n 1000 0 \n 1" | gibbs2f90 | tee gibbs.log

# Remember, we are sampling 3 parameters 
. Random group 2
. Random group 3 (additive variance) 
. Residual variance

=> The 'gibbs_samples' file has all the samples we are taking, for all the parameters
   plus other info that will be used by 'postgibbsf90'
   
head -15 gibbs_samples
    -1     3     4
    1    2    2    1    1
    2    3    3    1    1
    3    0    0    1    1
       1       3
	   
# var_d       var_a       var_e
  1559.        1687.       1838. # Try calculating heritability:  1687/(1559+1687+1838)= 0.33
       2       3                 # Not a good estimate. Gibbs sampling needs many samples 
   1598.       1660.       1857. # To be able to calculate posterior mean of parameters 
       3       3
   1682.       1628.       1837.
       4       3
   1626.       1613.       1866.
       5       3
   1675.       1513.       1890.


=> Let''s run 'postgibbsf90'
. parameter file 
. burn in 
. sampling interval  # same as the one used to tun gibbs2f90

postgibbsf90 exmr99s1
. 0 burn in 
. 200 burn in 
OPTION se_covar_function p.var G_2_2_1_1+G_3_3_1_1+R_1_1
OPTION se_covar_function h2 G_3_3_1_1/(G_2_2_1_1+G_3_3_1_1+R_1_1)

! Note that now we have 5 parameters
. var_d # diagonal effect variance (random group 2)
. var_a # additive variance (random group 3)
. var_e # residual variance
. p.var # phenotypic variance by our option
. h2    # heritability by our option

=> Let''s look at some of the output files of 'postgibbsf90'
. 'postout'           # has posterior statistics (mean, SD...). The results are here!
. 'postgibbs_samples' # has the samples after processing by 'postgibbsf90'


 ***** TIP *********
# We can also use 'OPTION se_covar_function' when running gibbs2f90, but only postgibbsf90 will read it
*******************

. 'postgibbs_samples'
head -5 postgibbs_samples*
==> postgibbs_samples_noburnin <==   # No burn in; all 1000 samples are stored 
#   S_N   S_N_burn N_par var_d        var_a       var_e       p.var      h2        
       1        1     5   1559.       1687.       1838.       5084.      0.3318 # remember the h2 we calculated from the first sample in the gibbs sample file?
       2        2     5   1598.       1660.       1857.       5115.      0.3245
       3        3     5   1682.       1628.       1837.       5147.      0.3163
       4        4     5   1626.       1613.       1866.       5105.      0.3160
       5        5     5   1675.       1513.       1890.       5078.      0.2980

 ***** TIP *********
# run gibbsf90 only once and then cut samples as needed in 'postgibbsf90'
# You can also process samples using 'R' with packages like 'CODA' or 'BOA'
# but it's a lot more work. postgibbs is more convinient.
*******************

# Look at the graphs from POSTGIBBSF90 of the samples to determine  size of burn in




#=========================================================================================================
# Ex 08: Obtain EBV from 'gibbs2f90'

cd /home/natalia/blupf90-uf/lab1/ex8
cp ../exmr99s1 .  #parameter file for single trait model (update the VC!)
cp ../renco99s .  #data file 
cp ../renpe99s .  #pedigree file 


OPTION fixed_var all 3   # Solutions and posterior standard deviation (PSD)
                           # if no number is provided, solutions for all effects will be stored
 ***** TIP *********
 #Don't forget to updated the variance components in the parameter file!
 #We just estimated variance components in the previous exercise, and we'll use them 
*******************

# Let's run it
echo -e "exmr99s1_updatedVC \n 1000 200 \n 1" | gibbs2f90 | tee gibbs.log

#solutions stored in file: 'final_solutions'

head -5 final_solutions
trait/effect level          solution              SD
   1   3         1         28.19157666         31.61473585
   1   3         2         64.51485712         35.51792372
   1   3         3         61.90204106         31.37379971
   1   3         4         34.84404063         28.24232159


. 'solution': posterior mean of EBV
. 'SD': posterior standard deviation of EBV ('analogous' to the SE)
        can be used to obtain PEV, REL and ACC
		

#=========================================================================================================
# Ex 09 (OPTIONAL): Random regression models 

cd /home/natalia/blupf90-uf/lab1/ex9
cp ../renrr.par .  #parameter file 
cp ../datrr.leg .  #data file 
cp ../pedrr .      #pedigree file 


. Page 132 of Mrode''ls book ('Linear Models for Predicting Animal Breeding Value')
  Random regression example
  
. Page 325 in Apendix G of the book has the Legendre polinomials. 
  They are the same as columns 5-9 in the 'datrr.leg' file

renumf90 renrr.par | tee renum.log
. Also look at 'renf90.tables' and 'renf90.fields'

renumf90 renrr.par | tee renum.log 
blupf90 renf90.par | tee blup.log